/***************************************
http://social.msdn.microsoft.com/Forums/en/transactsql/thread/5b01b421-79fe-4c12-a1c3-11ce4f8802cc
***************************************/
Declare @MyTable Table ([Date] date, [Group] int);

Insert into @MyTable
Select '2012-05-31', 1 Union All
Select '2012-05-30', Null Union All
Select '2012-05-29', Null Union All
Select '2012-05-28', 1 Union All
Select '2012-05-27', Null Union All
Select '2012-05-26', 1 Union All
Select '2012-05-25', Null Union All
Select '2012-05-24', Null Union All
Select '2012-05-23', Null Union All
Select '2012-05-22', 1 Union All
Select '2012-05-21', Null Union All
Select '2012-05-20', Null Union All
Select '2012-05-19', Null Union All
Select '2012-05-18', 1 Union All
Select '2012-05-17', Null Union All
Select '2012-05-16', Null Union All
Select '2012-05-15', Null Union All
Select '2012-05-14', Null Union All
Select '2012-05-13', Null Union All
Select '2012-05-12', 1 Union All
Select '2012-05-11', NULL Union All
Select '2012-05-10', NULL; 

--Use Recursive CTE
; With CTE1
As
(
Select	[Date], [Group]
		, Row_Number() Over(Order By [Date] Desc) As RN
From	@MyTable
)
, CTE2
As
(
	Select	[Date], RN, RN As MyGroup
	From	CTE1
	Where	[Group] is not Null
			Union All
	Select	A.[Date], A.RN, B.MyGroup
	From	CTE1 A
				Inner Join
			CTE2 B
				On A.RN = B.RN + 1
	Where	A.[Group] Is Null
)

Select	Date, RN, MyGroup
		, Dense_Rank() Over(Order by MyGroup) As [Group]
From	CTE2
Order by [Date] Desc
Option (Maxrecursion 0);



--; With CTE1
--As
--(
--	Select	[Date], Row_Number() Over(Order by [Date] Desc) As RN
--	From	@MyTable
--	Where	[Group] is not Null
--)
--, CTE2
--As
--(
--	Select	A.[Date] As [End], IsNull(DateAdd(Day, 1, B.[Date]),'')  As [Start]
--	From	CTE1 A
--				Left Outer Join
--			CTE1 B
--				On A.RN = B.RN - 1
--	Where	DateDiff(Day, IsNull(B.[Date], ''), A.[Date]) > 1 --ensure consecutive dates with Group values are not included
--)

--Select	A.[Date]
--		, Dense_Rank() Over( Order by IsNull(B.[End], A.Date) Desc) As [Group]
--From	@MyTable A
--			Left Outer Join
--		CTE2 B
--			On A.Date Between B.[Start] and B.[End]
--Order By A.[Date] Desc;



--;With CTE
--AS
--(
--Select	[Date], [Group]
--		, Row_Number() Over(Order By [Date] Desc) As RN
--		, Row_Number() Over(Partition By [Group] Order By [Date] Desc) As GroupRN
--From	@MyTable
--)

--Select	[Date]
--		, Dense_Rank() Over( Order By DateAdd(	Day
--												, Case When [Group] is Null Then GroupRN 
--													Else RN - GroupRN End
--												, [Date]) Desc
--							) As [Group]
--From	CTE
--Order by [Date] Desc;

----Solution 3

---- SQL Server 2005 to SQL Server 2008 R2
--		f.cnt AS [Group]
--FROM		@MyTable AS t
--CROSS APPLY	(
--			SELECT	COUNT(x.[Group])
--			FROM	@MyTable AS x
--			WHERE	x.[Date] >= t.[Date]
--		) AS f(cnt)
--ORDER BY	t.[Date] DESC

-- SQL Server 2012
--SELECT		[Date],
--		COUNT([Group]) OVER (ORDER BY [Date] DESC) AS [Group]
--FROM		@MyTable
--ORDER BY	[Date] DESC