/*****************************************************************************
This example is modified from Itzik Ben-Gan's book:
Microsoft SQL Server 2012 High-performance T-SQL Using Window Functions
*****************************************************************************/
--Gap for integer data
Create Table #NumberData (Number int not null Primary Key);

Insert Into #NumberData
Values	(1), (2), (4), (5), (6), (12), (13), (14), (18), (50);

Select Number From #NumberData;
;With CTE
AS
(
Select	Number
		, Number - Dense_Rank() Over(Order By Number) As MyGroup
From	#NumberData
)

Select	Min(Number) As RangeStart
		, Max(Number) As RangeEnd
From	CTE
Group By MyGroup;

Drop Table #NumberData;



--Gap for temporal data
Create Table #TemporalData (Period Date not null Primary Key);

Insert Into #TemporalData
Values	('20120822'), ('20120823'), ('20120824'), ('20120828'), ('20120829'), ('20120904')
		, ('20120905'), ('20120906'), ('20120907'), ('20121106');

--Select Period From #TemporalData;
;With CTE
AS
(
Select	Period
		, DateAdd(Day, -1 * Dense_Rank() Over(Order By Period), Period) As MyGroup
From	#TemporalData
)

Select	Min(Period) As RangeStart
		, Max(Period) As RangeEnd
From	CTE
Group By MyGroup;

Drop Table #TemporalData;