/***************************************
http://social.msdn.microsoft.com/Forums/en-US/transactsql/thread/f1426cd8-8e86-41e5-8308-58f0c5e23967
***************************************/

DECLARE @MyTable TABLE	(
							ColA BIGINT Not Null,
							ColB BIGINT Not Null,
							ColC BIGINT
						);

INSERT INTO @MyTable
Values
	(1, 2, 6)
	, (1, 7, 12)
	, (1, 13, 29)
	, (1, 31, 50)
	, (1, 51, 76)
	, (1, 79, 99)
	, (1, 100, 206)
	, (1, 300, 511)
	, (2, 38, 49)
	, (2, 50, 209)
	, (2, 402, 550)
	, (4, 1006, 2009)
	, (5, 1000, 1009)
	, (5, 1137, 1289)
	, (5, 1290, 1355);

--technical 1: expand the number with a number table
--technical 2: use the lag function
;With CTE
As
(
Select	ColA, ColB, ColC
		, ColB - Lag(ColC, 1, ColB - 1) Over(Partition By ColA Order By ColB) - 1 AS Change
From	@MyTable
) 
, RangeGroup
As
(
Select	ColA, ColB, ColC
		, Sum(Change) Over(Partition By ColA Order By ColB Rows Unbounded Preceding) As MyGroup
From	CTE
)

Select	ColA, Min(ColB) As RangeStart, Max(ColC) As RangeEnd
From	RangeGroup
Group By ColA, MyGroup
Order By ColA, RangeStart


--;
--With A
--As
--(
--Select	A.COLA
--		, A.COLB
--		, A.COLC
--From	@MyTable A
--Where	Not EXists (	Select	* 
--						From	@MyTable B
--						Where	A.COLA = B.ColA
--								And A.COLB - 1 = B.ColC
--					)
--),
--B
--As
--(
--Select A.COLA
--		, A.COLB
--		, A.COLC    
--		, A.ColB As ColBStart             
--From	A                 
--	Union All
--Select C.COLA
--		, C.COLB
--		, C.COLC  
--		, B.ColBStart              
--From	@MyTable C 
--			Inner Join 
--		B
--			On	B.ColA = C.ColA
--				And B.ColC + 1 = C.ColB 
--)

--SELECT	B.ColA
--		, Min(B.COLB) AS COLB
--		, MAX(B.COLC) AS COLC
--FROM	B
--GROUP BY B.COLA, B.ColBStart
--Order by B.COLA, B.ColBStart

