/*****************************************************************************
This example is modified from Itzik Ben-Gan's book:
Microsoft SQL Server 2012 High-performance T-SQL Using Window Functions
*****************************************************************************/
--Gap for integer data
Create Table #NumberData (Number int not null Primary Key);

Insert Into #NumberData
Values	(1), (2), (4), (5), (6), (12), (13), (14), (18), (50);

--Select Number From #NumberData;
;With CTE
AS
(
Select	Number
		, Lead(Number) Over(Order By Number) As FollowingNumber
From	#NumberData
)

Select	Number + 1 As GapStart
		, FollowingNumber - 1 As GapEnd
From	CTE
Where	FollowingNumber - Number > 1;

Drop Table #NumberData;



--Gap for temporal data
Create Table #TemporalData (Period Date not null Primary Key);

Insert Into #TemporalData
Values	('20120822'), ('20120823'), ('20120824'), ('20120828'), ('20120829'), ('20120904')
		, ('20120905'), ('20120906'), ('20120907'), ('20121106');

--Select Period From #TemporalData;
;With CTE
AS
(
Select	Period
		, Lead(Period) Over(Order By Period) As FollowingPeriod
From	#TemporalData
)

Select	DateAdd(Day, 1, Period) As GapStart
		, DateAdd(Day, -1, FollowingPeriod) As GapEnd
From	CTE
Where	DateDiff(Day, Period, FollowingPeriod) > 1;

Drop Table #TemporalData;