/**************************************************************
http://social.msdn.microsoft.com/Forums/en-US/transactsql/thread/c2a715a5-335d-4ec2-813f-8930faf4f83b
**************************************************************/

Declare @MyTable Table (Category varchar(20), MyValue int);

Insert into @MyTable
Select 'A', 20 Union All
Select 'B', 10 Union All
Select 'C', 190 Union All
Select 'D', 140 Union All
Select 'E', 20 Union All
Select 'F', 4 Union All
Select 'G', 9 Union All
Select 'H', 230 Union All
Select 'I', 10 Union All
Select 'J', 30 Union All
Select 'K', 21 Union All
Select 'L', 7 Union All
Select 'M', 3 Union All
Select 'N', 5 Union All
Select 'O', 1

Select	Category, MyValue
		, Cast(	100.0 
					* 
				Sum(MyValue) Over(Order By MyValue Desc Rows Unbounded Preceding)
					/ 
				Sum(MyValue) Over() As decimal(5,2)
			) As CumulativePct
		, Cast(CUME_DIST() Over(Order By MyValue Desc) * 100 as decimal(5,2)) As PopulationPct
From	@MyTable
Order by MyValue Desc



/**************************************************************
The Pareto chart gets its name from Vilfredo Pareto, an Italian Economist. In 1906
, Pareto noted that 20% of the population in Italy owned 80% of the property. 
He proposed that this ratio could be found many places in the physical world 
and theorized it might be a natural law, where 80% of the outcomes are determined 
by 20% of the inputs. 
**************************************************************/